Title Lab2 Program
;
list p=16c74 ; processor type

errorlevel 1, -(305)
;
#include "p16c74.inc"
;
Stat1 equ 20h

Adres equ 21h

CntByte equ 22h
Shif equ 23h
RxBuf equ 24h
CntShi equ 25h
ByteX equ 26h
ByteY equ 27h
cntrz_ equ 28h

org 00h
;  
movlw 0
movwf PCLATH
goto Start
org 04h ; 
nop
org 100h ;  
Start ;  
call ConstInit

DirBD;   RB, RD
bsf STATUS,RP0
movlw 0Ah ; 0 -    
movwf TRISB
movlw  05h
movwf TRISD
bcf STATUS,RP0

BegUst
movlw 60h ;        '01100000'
movwf PORTB ; 
clrf PORTD
clrf Adres
goto Answer

Priem
call Receiv
movlw 2
xorwf PORTA,f
movlw 0FFh
movwf cntrz_
cntrzz
nop
nop
nop
decf cntrz_
btfss STATUS,Z
goto cntrzz
movlw 2
xorwf PORTA,f

;    
Pusk bcf PORTE,2 ; CLR=0
bsf PORTC,1 ; U0=1
bsf PORTC,2 ; U1=1
bsf PORTC,0 ; RD=1
bsf PORTE,2 ; CLR=1

Command

movf RxBuf,w ;  
xorlw 'r'
btfsc STATUS,Z
goto BegUst
movf RxBuf,w
xorlw 'R'
btfsc STATUS,Z
goto BegUst

movf RxBuf,w ; w - WriteEnable
xorlw 'w'
btfsc STATUS,Z
goto WriteIt
goto Priem
movf RxBuf,w
xorlw 'W'
btfsc STATUS,Z
goto WriteIt
goto Priem

movf RxBuf,w ; c - ChipSelect
xorlw 'c'
btfsc STATUS,Z
goto CSe
goto Priem
movf RxBuf,w
xorlw 'C'
btfsc STATUS,Z
goto CSe
goto Priem

movf RxBuf,w ; i - IncremenentAdres
xorlw 'i'
btfsc STATUS,Z
goto IncAdr
goto Priem
movf RxBuf,w
xorlw 'I'
btfsc STATUS,Z
goto IncAdr
goto Priem

movf RxBuf,w ; d - DecremenentAdres
xorlw 'd'
btfsc STATUS,Z
goto DecAdr
goto Priem
movf RxBuf,w
xorlw 'D'
btfsc STATUS,Z
goto DecAdr
goto Priem

movf RxBuf,w ; 1-4 - toggle bits on D1 - D4
xorlw '1'
btfsc STATUS,Z
goto TBi1
goto Priem

movf RxBuf,w
xorlw '2'
btfsc STATUS,Z
goto TBi2
goto Priem

movf RxBuf,w
xorlw '3'
btfsc STATUS,Z
goto TBi3
goto Priem

movf RxBuf,w
xorlw '4'
btfsc STATUS,Z
goto TBi4
goto Priem

WriteIt
movfw PORTB
xorlw 20h ;'00100000'
movwf PORTB
goto Answer

CSe
movfw PORTB
xorlw 40h ;'01000000'
movwf PORTB
goto Answer

IncAdr
incf Adres
btfsc Adres,4 ; btfsc ,  (0 - 7)
clrf Adres ;A1=PORTB(7),A2=PORTD(7),A3=PORTD(6),A4=PORTD(5)
call NibbleToAdr
goto Answer

DecAdr
movlw b'1111'
decf Adres
btfsc Adres,7
andwf Adres ;A1=PORTB(7),A2=PORTD(7),A3=PORTD(6),A4=PORTD(5)
call NibbleToAdr
goto Answer

TBi1
movlw b'10000';D1=PORTB(4),D2=PORTB(2),D3=PORTD(1),D4=PORTD(4)
xorwf PORTB
goto Answer

TBi2
movlw b'100'
xorwf PORTB
goto Answer

TBi3
movlw b'10'
xorwf PORTD
goto Answer

TBi4
movlw b'10000'
xorwf PORTD
goto Answer

Answer ;  PORTD, PORTB
movf PORTD,w
call Transm
movf PORTB,w
call Transm
;  CLKU
movlw b'11111001'
andwf PORTC,f ; U1=0, U0=0
bcf PORTC,0 ; RD=0
;     6 
movlw 3
movwf CntByte

RdTrans
call RdAlt
movf ByteX,w
call Transm
movf ByteY,w
call Transm
decfsz CntByte
goto RdTrans
goto Priem
ConstInit
bsf STATUS,RP0
movlw b'10000000' ; RC7/RX in
movwf TRISC
movlw b'111100' ;A0,RA1 out diod
movwf TRISA
movlw b'011' ;LR out
movwf TRISE
movlw d'129'
movwf SPBRG
movlw b'00100100'
movwf TXSTA
bcf STATUS,RP0
clrf INTCON
clrf PORTC
movlw b'10010000'
movwf RCSTA
return
Receiv ; 
clrf STATUS ; Bank 0
RecA btfss PIR1,RCIF ; check for received data
goto RecA
RecB movf RCREG,w
movwf RxBuf
return
Transm ; 
clrf STATUS
movwf TXREG ; transmit byte to PC

bcf PIR1,TXIF
tr3 btfss PIR1,TXIF
goto tr3
return
RdAlt ;  2  
movlw 8
movwf Shif
Rd1 bcf STATUS,C
btfsc PORTE,0
bsf STATUS,C
rlf ByteX,f
bcf STATUS,C
btfsc PORTE,1
bsf STATUS,C
rlf ByteY,f
bsf PORTC,3
bcf PORTC,3 ; CLKU=1,0
decfsz Shif
goto Rd1
return

NibbleToAdr
btfsc Adres,0
bsf PORTB,7
btfss Adres,0
bcf PORTB,7
btfsc Adres,1
bsf PORTD,7
btfss Adres,1
bcf PORTD,7
btfsc Adres,2
bsf PORTD,6
btfss Adres,2
bcf PORTD,6
btfsc Adres,3
bsf PORTD,5
btfss Adres,3
bcf PORTD,5
return

end
